<?

   // ------------------------------------------------------------------------------------------------
	function CreateCategory ($Name, $Parent, $Position) {
	   $CategoryId = @IPS_GetCategoryIDByName($Name, $Parent);
	   if ($CategoryId === false) {
 			$CategoryId = IPS_CreateCategory();
   		IPS_SetName($CategoryId, $Name);
   		IPS_SetParent($CategoryId, $Parent);
   		IPS_SetPosition($CategoryId, $Position);
	   }
		echo 'Category '.$Name.'='.$CategoryId."\n";
		return $CategoryId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateInstance ($Name, $ParentId, $ModulId, $Position=0) {
		$InstanceId = @IPS_GetInstanceIDByName($Name, $ParentId);
		if ($InstanceId === false) {
			$InstanceId	= IPS_CreateInstance($ModulId);
			IPS_SetName($InstanceId, $Name);
			IPS_SetParent($InstanceId, $ParentId);
   		    IPS_SetPosition($InstanceId, $Position);
		}
		echo "Instance $Name=$InstanceId, ModuleID=$ModulId\n";
		return $InstanceId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateScript ($Name, $File, $Parent, $Position=0) {
		$ScriptId = @IPS_GetScriptIDByName($Name, $Parent);
		if ($ScriptId ===false) {
			$ScriptId = IPS_CreateScript(0);
   		IPS_SetName($ScriptId, $Name);
 			IPS_SetScriptFile($ScriptId, $File);
			IPS_SetParent($ScriptId, $Parent);
   		IPS_SetPosition($ScriptId, $Position);
		}
		echo 'Script '.$Name.'='.$ScriptId."\n";
		return $ScriptId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateVariable ($Name, $Type, $Parent, $Position, $Profile, $Action=null) {
	   $VariableId = @IPS_GetVariableIDByName($Name, $Parent);
	   if ($VariableId === false) {
 			$VariableId = IPS_CreateVariable($Type);
   		IPS_SetName($VariableId, $Name);
   		IPS_SetParent($VariableId, $Parent);
   		IPS_SetPosition($VariableId, $Position);
   		if ($Profile <> "") {
	  			IPS_SetVariableCustomProfile($VariableId, $Profile);
   		}
   		if ($Action <> null) {
   			IPS_SetVariableCustomAction($VariableId, $Action);
   		}
		}
		echo 'VariableId '.$Name.'='.$VariableId."\n";
		return $VariableId;
	}

   // ------------------------------------------------------------------------------------------------
	function SetVariableConstant ($Name, $ID, $FileName) {
	   $FileNameFull = IPS_GetKernelDir().'scripts/'.$FileName;
   	$FileContent = file_get_contents($FileNameFull, true);

		$pos = strpos($FileContent, $Name);
		if ($pos === false) {
		  echo "Error - ".$Name." could NOT be found in FileContent!\n";
		}
		$pos = $pos + strlen($Name);
		while (substr($FileContent, $pos, 1) < "0" or substr($FileContent, $pos, 1) > "9") {
			$pos = $pos+1;
		}
		$FileContentNew = substr($FileContent, 0, $pos).$ID.substr($FileContent, $pos+5);

   	file_put_contents($FileNameFull, $FileContentNew);
	}

   // ------------------------------------------------------------------------------------------------
	function CreateLink ($Name, $Link, $Parent, $Position) {
	   $LinkId = @IPS_GetLinkIDByName($Name, $Parent);
	   if ($LinkId === false) {
 			$LinkId = IPS_CreateLink();
   		IPS_SetName($LinkId, $Name);
			IPS_SetLinkChildID($LinkId, $Link);
   		IPS_SetParent($LinkId, $Parent);
   		IPS_SetPosition($LinkId, $Position);
	   }
		echo 'Link '.$Name.'='.$LinkId."\n";
		return $LinkId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateTimer_OnceADay ($Name, $Parent, $Hour) {
	   $TimerId = @IPS_GetEventIDByName($Name, $Parent);
	   if ($TimerId === false) {
 			$TimerId = IPS_CreateEvent(1 /*Cyclic Event*/);
   		IPS_SetName($TimerId, $Name);
   		IPS_SetParent($TimerId, $Parent);
			if (!IPS_SetEventCyclic($TimerId, 2 /**Daily*/, 1,0,0,0,0)) {
				echo "IPS_SetEventCyclic failed !!!\n";
				exit;
			}
			if (!IPS_SetEventCyclicTimeBounds($TimerId, mktime($Hour, 0, 0), 0)) {
				echo "IPS_SetEventCyclicTimeBounds failed !!!\n";
				exit;
			}
   		IPS_SetEventActive($TimerId, true);
		}
		echo 'Timer '.$Name.'='.$TimerId."\n";
		return $TimerId;
	}

   // ------------------------------------------------------------------------------------------------
	function CreateMediaPlayer($Name, $ParentId, $Position=0) {
		$MediaPlayerInstanceId = CreateInstance($Name, $ParentId, "{2999EBBB-5D36-407E-A52B-E9142A45F19C}",$Position);
		$SoundCards = WAC_GetDevices($MediaPlayerInstanceId);
		foreach ($SoundCards as $Idx=>$SoundCard) {
			if ($SoundCard <> "No sound") {
				echo "Set Soundcard $SoundCard\n";
			   WAC_SetDeviceID($MediaPlayerInstanceId, $Idx);
			}
		}
		WAC_SetUpdateInterval($MediaPlayerInstanceId, 1);
		IPS_ApplyChanges($MediaPlayerInstanceId);
		
		return $MediaPlayerInstanceId;
	}


?>